//Zofia Kruczkiewicz
#include <conio.h>
#include <alloc.h>
#include <string.h>
#include <stdlib.h>
//1. definicja typu struktury przechowujacej dane
const int DL=10;
 struct OSOBA
	{
	 int Numer;
	 char Nazwisko[DL];
	};

//2.  deklaracje i definicje funkcji obslugujacych wiazana strukture danych
//typu kolejka

 typedef struct ELEMENT* PELEMENT;
 typedef  void(* zrob)(OSOBA&);
 struct ELEMENT
 {
	OSOBA Dane;
	PELEMENT Nastepny;
 };

 PELEMENT Nowy_Element(OSOBA N_Dane);
 void Inicjalizacja(PELEMENT& Poczatek, PELEMENT& Koniec);
 inline int Pusty(PELEMENT Poczatek)	{return Poczatek==NULL;	}
 int Wstaw(PELEMENT& Poczatek, PELEMENT& Koniec, OSOBA Pozycja);
 int Usun(PELEMENT& Poczatek, PELEMENT& Koniec);
 void Usun_Pamiec(PELEMENT& Poczatek, PELEMENT& Koniec);
 int Dla_kazdego(PELEMENT Poczatek, zrob funkcja);
 int Dla_jednego(PELEMENT Poczatek, zrob funkcja);




 void Inicjalizacja(PELEMENT& Poczatek, PELEMENT& Koniec)
 { Poczatek = Koniec = NULL;	}

 PELEMENT Nowy_Element(OSOBA N_Dane)
	{PELEMENT Nowy;
	 Nowy = new ELEMENT;
	 if (!Pusty(Nowy))	Nowy->Dane=N_Dane;
	 return Nowy;
	}

 int Wstaw(PELEMENT& Poczatek, PELEMENT& Koniec, OSOBA Pozycja)
	{ PELEMENT Nowy;
		Nowy = Nowy_Element(Pozycja);
		if (Pusty(Nowy)) return 1;
		if (Pusty(Poczatek)) Poczatek=Nowy;
		else Koniec->Nastepny= Nowy;
		Koniec= Nowy;
		Koniec->Nastepny= NULL;
		return 0;
	 }

 int Usun(PELEMENT& Poczatek, PELEMENT& Koniec)
	{PELEMENT Pop;
	 if (Pusty(Poczatek)) return 1;
	 Pop = Poczatek;
	 Poczatek = Poczatek->Nastepny;
	 delete Pop;
	 if (Pusty(Poczatek)) Koniec = NULL;
	 return 0;
	}

 void Usun_Pamiec(PELEMENT& Poczatek, PELEMENT& Koniec)
	{ PELEMENT Pom;
		while (!Pusty(Poczatek))
		{
		 Pom= Poczatek;
		 Poczatek= Poczatek->Nastepny;
		 delete Pom;
		}
		Koniec= NULL;
	 }

 int Dla_kazdego(PELEMENT Poczatek, zrob funkcja)
	{
	 if (Pusty(Poczatek)) return 1;
	 while (!Pusty(Poczatek))
		{
		 funkcja(Poczatek->Dane);
		 Poczatek=Poczatek->Nastepny;
		}
	 return 0;
	}

 int Dla_jednego(PELEMENT Poczatek, zrob funkcja)
	{ if (Pusty(Poczatek)) return 1;
		funkcja(Poczatek->Dane);
		return 0;
	}

 const int POZ=5;
 //3. funkcje ogolnego przeznaczenia
	void Komunikat(char*);
	char Menu(const int ile, char *Polecenia[]);

 char Menu(const int ile, char *Polecenia[])
	{
	 clrscr();
	 for (int i=0; i<ile;i++)
		cprintf("\r\n%s",Polecenia[i]);
	 return getch();
	}

	void Komunikat(char* s)
	{
	 cprintf(s); getch();
	}

//4. funkcje we/wy dla struktur
 void Pokaz_dane (OSOBA &Dana);
 OSOBA Dane();



	OSOBA Dane()
	 {
		char bufor[DL+2];
		OSOBA Nowy;
		bufor[0]=DL;
		cprintf("\r\nnumer: ");
		cgets(bufor);
		Nowy.Numer=atoi(bufor+2);
		cprintf("\r\nnazwisko: ");
		strcpy(Nowy.Nazwisko,cgets(bufor));
		return Nowy;
	 }

	void Pokaz_dane(OSOBA &Dana)
	 {
		cprintf("\r\nNumer: %d\r\n", Dana.Numer);
		cprintf("Nazwisko:        %s\r\n", Dana.Nazwisko);
		cprintf("Nacisnij dowolny klawisz...\r\n"); getch();
	 }


 //5. deklaracje i definicje elementow na rzecz konkretnego programu

 char * Tab_menu[POZ] = {"1 : Wstawianie do kolejki- na koniec",
			 "2 : Usuwanie z kolejki-na poczatku",
			 "3 : Wydruk kolejki",
			 "4 : Usun kolejke",
			 "1<>4 Koniec programu"};

void Wstaw_(PELEMENT& Poczatek, PELEMENT& Koniec);
void main(void)
 { PELEMENT Poczatek, Koniec; char Wybor;
	 clrscr();
	 Inicjalizacja(Poczatek, Koniec);
	 do
	 { Wybor= Menu(POZ, Tab_menu);
		 switch	(Wybor)
		 {case '1' : Wstaw_(Poczatek, Koniec); break;
			case '2' : if (Usun(Poczatek, Koniec))
			Komunikat("\r\nKolejka pusta"); break;
			case '3' : if (Dla_kazdego(Poczatek, Pokaz_dane))
			Komunikat("\r\nKolejka pusta");break;
      case '4' : Usun_Pamiec(Poczatek, Koniec);
     }
    } while (Wybor < '5' && Wybor >'0' );
  }

 void Wstaw_(PELEMENT& Poczatek, PELEMENT& Koniec)
  {  OSOBA Dana;
     Dana= Dane();
		 if (Wstaw(Poczatek, Koniec, Dana)) Komunikat("\r\nBrak pamieci");
     else Dla_jednego(Koniec, Pokaz_dane);
  }
