//Zofia Kruczkiewicz
#include <conio.h>
#include <stdio.h>
#include <alloc.h>
#include <stdlib.h>
#include <string.h>

//1. definicja typu struktury przechowujaca dane
 const int DL=10;
 struct OSOBA
	{
	 int Numer;
	 char Nazwisko[DL];
	};


//2. deklaracje i definicje funkcji przetwarzajacych wiazana strukture
//danych typu dwukierunkowa lista nieuporzadkowana

 typedef struct ELEMENTD* PELEMENTD;
 typedef  void(* zrob)(OSOBA&);
 struct ELEMENTD
	{
	 OSOBA Dane;
	 PELEMENTD Nastepny, Poprzedni;
	};

 PELEMENTD Nowy_Element(OSOBA N_Dane);
 void Inicjalizacja(PELEMENTD& Poczatek);
 inline int Pusty(PELEMENTD Poczatek)	{ return Poczatek == NULL; }
 int Szukaj(PELEMENTD Poczatek, long Miejsce, PELEMENTD& Gdzie);
 int Wstaw(PELEMENTD& Poczatek, OSOBA Pozycja, PELEMENTD Gdzie);
 int Usun(PELEMENTD& Poczatek, PELEMENTD Gdzie);
 void Usun_Pamiec(PELEMENTD& Poczatek);
 int Dla_kazdego(PELEMENTD Poczatek, zrob funkcja);
 int Dla_jednego(PELEMENTD Poczatek, PELEMENTD Gdzie, zrob funkcja);



 void Inicjalizacja(PELEMENTD& Poczatek)
	{ Poczatek = NULL;}

 PELEMENTD Nowy_Element(OSOBA N_Dane)
 {PELEMENTD Nowy;
	Nowy = new ELEMENTD;
	if (!Pusty(Nowy))	Nowy->Dane=N_Dane;
	return Nowy;
 }

 int Szukaj(PELEMENTD Poczatek,long Miejsce, PELEMENTD& Gdzie)
	{long  Numer= 1;
	 Gdzie = Poczatek;
	 if (Pusty(Poczatek)) return 0;
	 while (!Pusty(Gdzie->Nastepny) && Miejsce != Numer)
		{ Gdzie= Gdzie->Nastepny;
			Numer++; }
	 if (Miejsce == Numer) Gdzie= Gdzie->Poprzedni;
	 return  (Miejsce == Numer || Miejsce == Numer+1);
	}

 int Wstaw(PELEMENTD& Poczatek, OSOBA Pozycja, PELEMENTD Gdzie)
	{ PELEMENTD Nowy;
		Nowy = Nowy_Element(Pozycja);
		if (Pusty(Nowy)) return 1;
		if (Pusty(Gdzie))
		 { Nowy->Nastepny=Poczatek;
			if (Poczatek!=NULL) Poczatek->Poprzedni=Nowy;                  \
			Poczatek=Nowy;
		 }
	 else
		{ Nowy->Nastepny=Gdzie->Nastepny;
	 if (Gdzie->Nastepny != NULL)
		 Gdzie->Nastepny->Poprzedni=Nowy;
	 Gdzie->Nastepny=Nowy;}
	 Nowy->Poprzedni=Gdzie;
	 return 0;
	 }

 int Usun(PELEMENTD& Poczatek, PELEMENTD Gdzie)
	{
	 if (Pusty(Gdzie)) Gdzie=Poczatek;
	 else
		if (!Pusty(Gdzie->Nastepny)) Gdzie= Gdzie->Nastepny;
		else return 1;
	 if (Gdzie->Poprzedni != NULL)
		 Gdzie->Poprzedni->Nastepny=Gdzie->Nastepny;
	 else	Poczatek=Gdzie->Nastepny;
	 if (Gdzie->Nastepny != NULL)
		Gdzie->Nastepny->Poprzedni=Gdzie->Poprzedni;
	 delete Gdzie;
	 return 0;
	}

 void Usun_Pamiec(PELEMENTD& Poczatek)
 { PELEMENTD Pom;
	 while (!Pusty(Poczatek))
		{
		 Pom= Poczatek;
		 Poczatek= Poczatek->Nastepny;
		 delete Pom;
		}
	 }

 int Dla_kazdego(PELEMENTD Poczatek, zrob funkcja)
	 {
		if (Pusty(Poczatek)) return 1;
		while (!Pusty(Poczatek))
		 {
			funkcja(Poczatek->Dane);
			Poczatek=Poczatek->Nastepny;
		 }
		return 0;
	 }

 int Dla_jednego(PELEMENTD Poczatek, PELEMENTD Gdzie, zrob funkcja)
	 { if(Pusty(Gdzie)) Gdzie= Poczatek;
		 else
			if (!Pusty(Gdzie->Nastepny)) Gdzie= Gdzie->Nastepny;
			else return 1;
		 funkcja(Gdzie->Dane);
		 return 0;
	 }


	const int POZ=5;
 //3. funkcje ogolnego przeznaczenia
	void Komunikat(char*);
	char Menu(const int ile, char *Polecenia[]);

 char Menu(const int ile, char *Polecenia[])
	{
	 clrscr();
	 for (int i=0; i<ile;i++)
		cprintf("\r\n%s",Polecenia[i]);
	 return getch();
	}

	void Komunikat(char* s)
	{
	 cprintf(s); getch();
	}



//4. funkcje we/wy dla struktur
 void Pokaz_dane (OSOBA &Dana);
 OSOBA Dane();

	OSOBA Dane()
   {
    char bufor[DL+2];
    OSOBA Nowy;
    bufor[0]=DL;
    cprintf("\r\nnumer: ");
    cgets(bufor);
    Nowy.Numer=atoi(bufor+2);
    cprintf("\r\nnazwisko: ");
    strcpy(Nowy.Nazwisko,cgets(bufor));
    return Nowy;
   }

	void Pokaz_dane(OSOBA &Dana)
   {
    cprintf("\r\nNumer: %d\r\n", Dana.Numer);
    cprintf("Nazwisko:        %s\r\n", Dana.Nazwisko);
    cprintf("Nacisnij dowolny klawisz...\r\n"); getch();
   }

//5. deklaracje i definicje elementow na rzecz konkretnego programu

 char * Tab_menu[POZ] =
 {"1 : Wstawianie do listy dwukierunkowej nieuporzadkowanej",
	"2 : Usuwanie z listy dwukierunkowej nieuporzadkowanej",
	"3 : Wydruk listy",
	"4 : Usun liste",
	" 1<>4 Koniec programu"};

 void Wstaw_(PELEMENTD& Poczatek);
 void Usun_(PELEMENTD& Poczatek);
 void Podaj_numer(long& Numer);

	void main(void)
	 { PELEMENTD Poczatek; char Wybor;
		 clrscr();
		 Inicjalizacja(Poczatek);
		 do
		 { Wybor= Menu(POZ, Tab_menu);
			 switch (Wybor)
			 {case '1' : Wstaw_(Poczatek); break;
				case '2' : Usun_(Poczatek); break;
				case '3' : if (Dla_kazdego(Poczatek, Pokaz_dane))
												Komunikat("\r\nLista pusta");break;
				case '4' : Usun_Pamiec(Poczatek);
      }
     } while (Wybor < '5' && Wybor >'0' );
    }

 void Podaj_numer(long& Numer)
    {
     do
     { fflush(stdin);
       printf("\nPodaj Miejsce ");
     } while (!scanf("%ld",&Numer));
    }

 void Wstaw_(PELEMENTD& Poczatek)
    {  OSOBA Dana; long Miejsce; PELEMENTD Gdzie;
       Podaj_numer(Miejsce);
       if  (Szukaj(Poczatek, Miejsce, Gdzie) || Pusty(Poczatek))
	{ Dana= Dane();
	 if (Wstaw(Poczatek, Dana, Gdzie))
	   Komunikat("\r\nBrak pamieci");
	 else Dla_jednego(Poczatek, Gdzie, Pokaz_dane); }
       else Komunikat("\r\nNie znaleziono miejsca");
     }

 void Usun_(PELEMENTD& Poczatek)
     { long Miejsce; PELEMENTD Gdzie;
       Podaj_numer(Miejsce);
       if  (Szukaj(Poczatek, Miejsce, Gdzie))
         if( Usun(Poczatek, Gdzie))
	  Komunikat("\r\nNie mozna usuwac za oststnim elementem");
         else Komunikat("\r\nUsunieto element");
	else Komunikat("\r\nNie znaleziono miejsca");
       }
