//Zofia Kruczkiewicz
#include <conio.h>
#include <stdio.h>
#include <alloc.h>
#include <stdlib.h>
#include <string.h>
//1. definicja typu struktury przechowujacej dane

const int DL=10;
 struct OSOBA
	{
	 int Numer;
	 char Nazwisko[DL];
	};

//2. deklaracje i definicje funkcji obslugujacych wiazana strukture danych
//typu jednokierunkowa lista nieuporzadkowana

 typedef struct ELEMENT* PELEMENT;
 typedef  void(* zrob)(OSOBA&);
 struct ELEMENT
	{
	 OSOBA Dane;
	 PELEMENT Nastepny;
	};

 PELEMENT Nowy_Element(OSOBA N_Dane);
 void Inicjalizacja(PELEMENT& Poczatek);
 inline int Pusty(PELEMENT Poczatek)	{ return Poczatek == NULL; }
 int Szukaj(PELEMENT Poczatek, long Miejsce, PELEMENT& Gdzie);
 int Wstaw(PELEMENT& Poczatek, OSOBA Pozycja, PELEMENT Gdzie);
 int Usun(PELEMENT& Poczatek, PELEMENT Gdzie);
 void Usun_Pamiec(PELEMENT& Poczatek);
 int Dla_kazdego(PELEMENT Poczatek, zrob funkcja);
 int Dla_jednego(PELEMENT Poczatek, PELEMENT Gdzie, zrob funkcja);


 void Inicjalizacja(PELEMENT& Poczatek)
	{ Poczatek = NULL;}

 PELEMENT Nowy_Element(OSOBA N_Dane)
 {PELEMENT Nowy;
	Nowy = new ELEMENT;
	if (!Pusty(Nowy))	Nowy->Dane=N_Dane;
	return Nowy;
	}

	int Szukaj(PELEMENT Poczatek,long Miejsce, PELEMENT& Gdzie)
	 {long  Numer= 1; PELEMENT Nast;
		Gdzie = NULL;
		if (Pusty(Poczatek)) return 0;
		Nast = Poczatek;
		while (!Pusty(Nast->Nastepny) && Miejsce != Numer)
		 { Gdzie= Nast;
			 Nast = Nast->Nastepny;
			 Numer++; }
		if (Miejsce == Numer+1) Gdzie= Nast;
		return  (Miejsce == Numer || Miejsce == Numer+1);
	 }

 int Wstaw(PELEMENT& Poczatek, OSOBA Pozycja, PELEMENT Gdzie)
	 { PELEMENT Nowy;
		 Nowy = Nowy_Element(Pozycja);
		 if (Pusty(Nowy)) return 1;
		 if (Pusty(Gdzie))
			{	Nowy->Nastepny= Poczatek;
	Poczatek= Nowy;	}
		 else
			{ Nowy->Nastepny = Gdzie->Nastepny;
	Gdzie->Nastepny = Nowy;}
		 return 0;
		}

 int Usun(PELEMENT& Poczatek, PELEMENT Gdzie)
	 { PELEMENT Pop;
		 if (Pusty(Gdzie))
			{ Pop= Poczatek;
	Poczatek= Poczatek->Nastepny;}
		 else
			{	if (Pusty(Gdzie->Nastepny)) return 1;
	Pop= Gdzie->Nastepny;
	Gdzie->Nastepny= Pop->Nastepny;}
	delete Pop;
	return 0;
			}

 void Usun_Pamiec(PELEMENT& Poczatek)
	{ PELEMENT Pom;
		while (!Pusty(Poczatek))
		 {
			Pom= Poczatek;
			Poczatek= Poczatek->Nastepny;
			delete Pom;
		 }
		}

 int Dla_kazdego(PELEMENT Poczatek, zrob funkcja)
		{
		 if (Pusty(Poczatek)) return 1;
		 while (!Pusty(Poczatek))
			{
			 funkcja(Poczatek->Dane);
			 Poczatek=Poczatek->Nastepny;
			}
		 return 0;
		}

 int Dla_jednego(PELEMENT Poczatek, PELEMENT Gdzie, zrob funkcja)
	 { if(Pusty(Gdzie)) Gdzie= Poczatek;
		 else
			if (!Pusty(Gdzie->Nastepny)) Gdzie= Gdzie->Nastepny;
			else return 1;
		 funkcja(Gdzie->Dane);
		 return 0;
		}


 const int POZ=5;
 //3. funkcje ogolnego przeznaczenia
	void Komunikat(char*);
	char Menu(const int ile, char *Polecenia[]);

	char Menu(const int ile, char *Polecenia[])
	{
	 clrscr();
	 for (int i=0; i<ile;i++)
		cprintf("\r\n%s",Polecenia[i]);
	 return getch();
	}

	void Komunikat(char* s)
	{
	 cprintf(s); getch();
	}


 //4. funkcje we/wy dla struktur
 void Pokaz_dane (OSOBA &Dana);
 OSOBA Dane();


	OSOBA Dane()
	 {
		char bufor[DL+2];
		OSOBA Nowy;
		bufor[0]=DL;
		cprintf("\r\nnumer: ");
		cgets(bufor);
		Nowy.Numer=atoi(bufor+2);
		cprintf("\r\nnazwisko: ");
		strcpy(Nowy.Nazwisko,cgets(bufor));
		return Nowy;
	 }

	void Pokaz_dane(OSOBA &Dana)
	 {
		cprintf("\r\nNumer: %d\r\n", Dana.Numer);
		cprintf("Nazwisko:        %s\r\n", Dana.Nazwisko);
		cprintf("Nacisnij dowolny klawisz...\r\n"); getch();
	 }


//5. Elementy zadeklarowane i zdefiniowane na rzecz konkretnego programu

 char * Tab_menu[POZ] =
 {"1 : Wstawianie do listy jednokierunkowej nieuporzadkowanej",
	"2 : Usuwanie z listy jednokierunkowej nieuporzadkowanej",
	"3 : Wydruk listy",
	"4 : Usun liste",
	" 1< >4 Koniec programu"};

  void Wstaw_(PELEMENT& Poczatek);
  void Usun_(PELEMENT& Poczatek);
  void Podaj_numer(long& Numer);

  void main(void)
   { PELEMENT Poczatek; char Wybor;
     clrscr();
     Inicjalizacja(Poczatek);
     do
     { Wybor= Menu(POZ, Tab_menu);
       switch	(Wybor)
       {case '1' : Wstaw_(Poczatek); break;
				case '2' : Usun_(Poczatek); break;
				case '3' : if (Dla_kazdego(Poczatek, Pokaz_dane))
										 Komunikat("\r\nLista pusta");break;
				case '4' : Usun_Pamiec(Poczatek);
			}
     } while (Wybor < '5' && Wybor >'0' );
    }

 void Podaj_numer(long& Numer)
    {
     do
     { fflush(stdin);
       printf("\nPodaj Miejsce ");
     } while (!scanf("%ld",&Numer));
    }

 void Wstaw_(PELEMENT& Poczatek)
    {  OSOBA Dana; long Miejsce; PELEMENT Gdzie;
       Podaj_numer(Miejsce);
       if (Szukaj(Poczatek, Miejsce, Gdzie) || Pusty(Poczatek))
	{ Dana= Dane();
	if (Wstaw(Poczatek, Dana, Gdzie))
	  Komunikat("\r\nBrak pamieci");
	else Dla_jednego(Poczatek, Gdzie, Pokaz_dane); }
       else Komunikat("\r\nNie znaleziono miejsca");
    }

 void Usun_(PELEMENT& Poczatek)
    { long Miejsce; PELEMENT Gdzie;
      Podaj_numer(Miejsce);
      if  (Szukaj(Poczatek, Miejsce, Gdzie))
	if (Usun(Poczatek, Gdzie))
          Komunikat("\r\nNie mozna usuwac za ostatnim elementem");
         else Komunikat("\r\nUsunieto element");
      else Komunikat("\r\nNie znaleziono miejsca");
     }
