//Zofia Kruczkiewicz
#include <conio.h>
#include <alloc.h>
#include <stdlib.h>
#include <string.h>
//1. definicja typu struktury zawierajacej dane
const int DL=10;
 struct OSOBA
	{
	 int Numer;
	 char Nazwisko[DL];
	};

 //2. deklaracje i definicje funkcji obslugujacych wiazana
 //strukture danych typu stos

 typedef struct ELEMENT* PELEMENT;
 typedef  void(* zrob)(OSOBA&);
 struct ELEMENT
	{
	 OSOBA Dane;
	 PELEMENT Nastepny;
	};

 PELEMENT Nowy_Element(OSOBA N_Dane);
 void Inicjalizacja(PELEMENT& Poczatek);
 inline int Pusty(PELEMENT Poczatek);
 int Wstaw(PELEMENT& Poczatek, OSOBA Pozycja);
 int Usun(PELEMENT& Poczatek);
 void Usun_Pamiec(PELEMENT& Poczatek);
 int Dla_kazdego(PELEMENT Poczatek, zrob funkcja);
 int Dla_jednego(PELEMENT Poczatek, zrob funkcja);


 void Inicjalizacja(PELEMENT& Poczatek)
 {  Poczatek = NULL; }

 inline int Pusty(PELEMENT Poczatek)
 { return Poczatek==NULL;	}

 static PELEMENT Nowy_Element(OSOBA N_Dane)
	{ PELEMENT Nowy;
		Nowy = new ELEMENT;
		if (!Pusty(Nowy))	Nowy->Dane=N_Dane;
		return Nowy;
	}

 int Wstaw(PELEMENT& Poczatek, OSOBA Pozycja)
	{ PELEMENT Nowy;
		Nowy = Nowy_Element(Pozycja);
		if (Pusty(Nowy)) return 1;
		Nowy->Nastepny= Poczatek;
		Poczatek= Nowy;
		return 0;
	 }

 int Usun(PELEMENT& Poczatek)
	 {PELEMENT Pop;
		if (Pusty(Poczatek)) return 1;
		Pop = Poczatek;
		Poczatek = Poczatek->Nastepny;
		delete Pop;
		return 0;
	 }

 void Usun_Pamiec(PELEMENT& Poczatek)
	 { PELEMENT Pom;
		 while (!Pusty(Poczatek))
			{
	Pom= Poczatek;
	Poczatek= Poczatek->Nastepny;
	delete Pom;
			}
		}

 int Dla_kazdego(PELEMENT Poczatek, zrob funkcja)
		{
		 if (Pusty(Poczatek)) return 1;
		 while (!Pusty(Poczatek))
			{
	funkcja(Poczatek->Dane);
	Poczatek=Poczatek->Nastepny;
			}
		 return 0;
		}

 int Dla_jednego(PELEMENT Poczatek, zrob funkcja)
	{ if (Pusty(Poczatek)) return 1;
		funkcja(Poczatek->Dane);
		return 0;
	}

//3.  funkcje ogolnego przeznaczenia
 const int POZ=5;

	void Komunikat(char*);
	char Menu(const int ile, char *Polecenia[]);

 char Menu(const int ile, char *Polecenia[])
	{
	 clrscr();
	 for (int i=0; i<ile;i++)
		cprintf("\r\n%s",Polecenia[i]);
	 return getch();
	}

	void Komunikat(char* s)
	{
	 cprintf(s); getch();
	}


//4. funkcje we/wy dla struktur
 void Pokaz_dane (OSOBA &Dana);
 OSOBA Dane();


	OSOBA Dane()
	 {
		char bufor[DL+2];
		OSOBA Nowy;
		bufor[0]=DL;
		cprintf("\r\nnumer: ");
		cgets(bufor);
		Nowy.Numer=atoi(bufor+2);
		cprintf("\r\nnazwisko: ");
		strcpy(Nowy.Nazwisko,cgets(bufor));
		return Nowy;
	 }

	void Pokaz_dane(OSOBA &Dana)
	 {
		cprintf("\r\nNumer: %d\r\n", Dana.Numer);
		cprintf("Nazwisko:        %s\r\n", Dana.Nazwisko);
		cprintf("Nacisnij dowolny klawisz...\r\n"); getch();
	 }

//5. Elementy zadeklarowane i zdefiniowane na rzecz konkretnego programu

 char * Tab_menu[POZ] = {"1 : Wstawianie do stosu- na poczatek",
			 "2 : Usuwanie ze stosu-na poczatku",
			 "3 : Wydruk stosu",
			 "4 : Usun stos",
			 " >4 Koniec programu"};

void Wstaw_do_stosu(PELEMENT& Poczatek);

void main(void)
 { PELEMENT Poczatek_S;
	 char Wybor;

	 clrscr();
	 Inicjalizacja(Poczatek_S);
	 do
	 { Wybor= Menu(POZ, Tab_menu);
		switch (Wybor)
		{case '1' : Wstaw_do_stosu(Poczatek_S); break;
		 case '2' : if (Usun(Poczatek_S))
									Komunikat("\r\nStos pusty"); break;
		 case '3' : if (Dla_kazdego(Poczatek_S, Pokaz_dane))
											Komunikat("\r\nStos pusty") ;break;
		 case '4' : Usun_Pamiec(Poczatek_S);
		}
	 } while (Wybor < '5' && Wybor >'0' );
	}

 void Wstaw_do_stosu(PELEMENT& Poczatek)
	{  OSOBA Dana;
		 Dana= Dane();
		 if (Wstaw(Poczatek, Dana)) Komunikat("\r\nBrak pamieci");
		 else Dla_jednego(Poczatek, Pokaz_dane);
	}
